Index: palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- palm/trunk/SOURCE/init_pegrid.f90	(revision 1761)
+++ palm/trunk/SOURCE/init_pegrid.f90	(revision 1762)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Introduction of nested domain feature
 ! 
 ! Former revisions:
@@ -129,5 +129,6 @@
                io_blocks, io_group, maximum_grid_level,                        &
                maximum_parallel_io_streams, message_string,                    &
-               mg_switch_to_pe0_level, momentum_advec, neutral, psolver,       &
+               mg_switch_to_pe0_level, momentum_advec, nest_bound_l,           &
+               nest_bound_n, nest_bound_r, nest_bound_s, neutral, psolver,     &
                outflow_l, outflow_n, outflow_r, outflow_s, recycling_width,    &
                scalar_advec, subdomain_size 
@@ -147,4 +148,9 @@
     USE pegrid
  
+#if defined( PMC_ACTIVE )
+    USE pmc_interface,                                                         &
+        ONLY:  cpl_npex,cpl_npey
+#endif
+
     USE transpose_indices,                                                     &
         ONLY:  nxl_y, nxl_yd, nxl_z, nxr_y, nxr_yd, nxr_z, nyn_x, nyn_z, nys_x,&
@@ -206,4 +212,11 @@
     CALL location_message( 'creating virtual PE grids + MPI derived data types', &
                            .FALSE. )
+#if defined( PMC_ACTIVE )
+!
+!-- In case of nested-domain runs, the processor grid is explicitly given
+!-- by the user in the nestpar-NAMELIST
+    pdims(1) = cpl_npex
+    pdims(2) = cpl_npey
+#else
 !
 !-- Determine the processor topology or check it, if prescribed by the user
@@ -243,4 +256,5 @@
 
     ENDIF
+#endif
 
 !
@@ -1058,5 +1072,5 @@
 #if defined( __parallel ) && ! defined ( __check )
 !
-!-- Setting of flags for inflow/outflow conditions in case of non-cyclic
+!-- Setting of flags for inflow/outflow/nesting conditions in case of non-cyclic
 !-- horizontal boundary conditions.
     IF ( pleft == MPI_PROC_NULL )  THEN
@@ -1065,4 +1079,8 @@
        ELSEIF ( bc_lr == 'radiation/dirichlet' )  THEN
           outflow_l = .TRUE.
+#if defined( PMC_ACTIVE )
+       ELSEIF ( bc_lr == 'nested' )  THEN
+          nest_bound_l = .TRUE.
+#endif
        ENDIF
     ENDIF
@@ -1073,4 +1091,8 @@
        ELSEIF ( bc_lr == 'radiation/dirichlet' )  THEN
           inflow_r  = .TRUE.
+#if defined( PMC_ACTIVE )
+       ELSEIF ( bc_lr == 'nested' )  THEN
+          nest_bound_r = .TRUE.
+#endif
        ENDIF
     ENDIF
@@ -1081,4 +1103,8 @@
        ELSEIF ( bc_ns == 'radiation/dirichlet' )  THEN
           inflow_s  = .TRUE.
+#if defined( PMC_ACTIVE )
+       ELSEIF ( bc_ns == 'nested' )  THEN
+          nest_bound_s = .TRUE.
+#endif
        ENDIF
     ENDIF
@@ -1089,4 +1115,8 @@
        ELSEIF ( bc_ns == 'radiation/dirichlet' )  THEN
           outflow_n = .TRUE.
+#if defined( PMC_ACTIVE )
+       ELSEIF ( bc_ns == 'nested' )  THEN
+          nest_bound_n = .TRUE.
+#endif
        ENDIF
     ENDIF
@@ -1139,10 +1169,10 @@
 !-- At the inflow or outflow, u or v, respectively, have to be calculated for
 !-- one more grid point.
-    IF ( inflow_l .OR. outflow_l )  THEN
+    IF ( inflow_l .OR. outflow_l .OR. nest_bound_l )  THEN
        nxlu = nxl + 1
     ELSE
        nxlu = nxl
     ENDIF
-    IF ( inflow_s .OR. outflow_s )  THEN
+    IF ( inflow_s .OR. outflow_s .OR. nest_bound_s )  THEN
        nysv = nys + 1
     ELSE
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 1761)
+++ palm/trunk/SOURCE/modules.f90	(revision 1762)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! +nest_* variables, size of volume_flow arrays increased by one element
 !
 ! Former revisions:
@@ -711,4 +711,7 @@
                 masking_method = .FALSE., mg_switch_to_pe0 = .FALSE., &
                 monotonic_adjustment = .FALSE., &
+                nest_bound_l = .FALSE., nest_bound_n = .FALSE., &
+                nest_bound_r = .FALSE., nest_bound_s = .FALSE., &
+                nest_domain = .FALSE., &
                 neutral = .FALSE., nudging = .FALSE., &
                 ocean = .FALSE., on_device = .FALSE., &
@@ -828,6 +831,6 @@
                  vg_vertical_gradient(10) = 0.0_wp, &
                  vg_vertical_gradient_level(10) = -9999999.9_wp, &
-                 volume_flow(1:2) = 0.0_wp, volume_flow_area(1:2) = 0.0_wp, &
-                 volume_flow_initial(1:2) = 0.0_wp, wall_heatflux(0:4) = 0.0_wp, &
+                 volume_flow(1:3) = 0.0_wp, volume_flow_area(1:3) = 0.0_wp, &
+                 volume_flow_initial(1:3) = 0.0_wp, wall_heatflux(0:4) = 0.0_wp, &
                  wall_humidityflux(0:4) = 0.0_wp, wall_nrflux(0:4) = 0.0_wp, &
                  wall_qflux(0:4) = 0.0_wp, wall_qrflux(0:4) = 0.0_wp, &
Index: palm/trunk/SOURCE/palm.f90
===================================================================
--- palm/trunk/SOURCE/palm.f90	(revision 1761)
+++ palm/trunk/SOURCE/palm.f90	(revision 1762)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Introduction of nested domain feature
 !
 ! Former revisions:
@@ -113,5 +113,5 @@
         ONLY:  coupling_char, coupling_mode, do2d_at_begin, do3d_at_begin,     &
                io_blocks, io_group, large_scale_forcing, message_string,       &
-               nudging, simulated_time, simulated_time_chr,                    &
+               nest_domain, nudging, simulated_time, simulated_time_chr,       &
                user_interface_current_revision,                                &
                user_interface_required_revision, version, wall_heatflux,       &
@@ -144,4 +144,9 @@
 
     USE pegrid
+
+#if defined( PMC_ACTIVE )
+    USE pmc_interface,                                                         &
+        ONLY:  cpl_id, pmci_init, pmci_modelconfiguration
+#endif
 
     USE statistics,                                                            &
@@ -176,12 +181,28 @@
 !-- it will be defined in init_pegrid but is used before in cpu_log.
     CALL MPI_INIT( ierr )
+
+#if defined( PMC_ACTIVE )
+!
+!-- Initialize the coupling for nested-domain runs
+    CALL pmci_init( comm_palm )
+    comm2d = comm_palm
+
+    IF ( cpl_id >= 2 )  THEN
+       nest_domain = .TRUE.
+       WRITE( coupling_char, '(A1,I1.1)') '_', cpl_id
+    ENDIF
+
+    CALL MPI_COMM_SIZE( comm_palm, numprocs, ierr )
+    CALL MPI_COMM_RANK( comm_palm, myid, ierr )
+#else
     CALL MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
     CALL MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
     comm_palm = MPI_COMM_WORLD
     comm2d    = MPI_COMM_WORLD
-
-!
-!-- Initialize PE topology in case of coupled runs
+!
+!-- Initialize PE topology in case of coupled atmosphere-ocean runs (comm_palm
+!-- will be splitted in init_coupling)
     CALL init_coupling
+#endif
 #endif
 
@@ -291,4 +312,10 @@
 !-- Initialize all necessary variables
     CALL init_3d_model
+
+#if defined( PMC_ACTIVE )
+!
+!-- Coupling protocol setup for nested-domain runs
+    CALL pmci_modelconfiguration
+#endif
 
 !
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 1761)
+++ palm/trunk/SOURCE/parin.f90	(revision 1762)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Introduction of nested domain feature
 ! 
 ! Former revisions:
@@ -176,81 +176,5 @@
                limiter_sedimentation, nc_const, ventilation_effect
 
-    USE control_parameters,                                                    &
-        ONLY:  alpha_surface, averaging_interval, averaging_interval_pr,       &
-               bc_e_b, bc_lr, bc_ns, bc_p_b, bc_p_t, bc_pt_b, bc_pt_t,         &
-               bc_q_b, bc_q_t,bc_s_b, bc_s_t, bc_sa_t, bc_uv_b, bc_uv_t,       &
-               bottom_salinityflux, building_height, building_length_x,        &
-               building_length_y, building_wall_left, building_wall_south,     &
-               call_microphysics_at_all_substeps, call_psolver_at_all_substeps,&
-               canyon_height,                                                  &
-               canyon_width_x, canyon_width_y, canyon_wall_left,               &
-               canyon_wall_south, cfl_factor,                                  &
-               cloud_droplets, cloud_physics, cloud_scheme,                    &
-               cloud_top_radiation, conserve_volume_flow,                      &
-               conserve_volume_flow_mode, constant_flux_layer,                 &
-               coupling_start_time,                                            &
-               create_disturbances, cycle_mg, data_output, data_output_masks,  &
-               data_output_pr, data_output_2d_on_each_pe,                      &
-               disturbance_amplitude, disturbance_energy_limit,                &
-               disturbance_level_b, disturbance_level_t, dissipation_1d,       &
-               do2d_at_begin, do3d_at_begin,                                   &
-               dp_external, dp_level_b, dp_smooth, dpdxy,                      &
-               drizzle, dt, dt_averaging_input, dt_averaging_input_pr,         &
-               dt_coupling, dt_data_output, dt_data_output_av, dt_disturb,     &
-               dt_domask, dt_dopr, dt_dopr_listing, dt_dots, dt_do2d_xy,       &
-               dt_do2d_xz, dt_do2d_yz, dt_do3d, dt_max, dt_restart,            &
-               dt_run_control, dz, dz_max, dz_stretch_factor, dz_stretch_level,&
-               end_time, ensemble_member_nr, e_init, e_min, fft_method,        &
-               force_print_header,                                             &
-               galilei_transformation, host, humidity, inflow_damping_height,  &
-               inflow_damping_width, inflow_disturbance_begin,                 &
-               inflow_disturbance_end,  initializing_actions, io_blocks,       &
-               io_group, km_constant,                                          &
-               large_scale_forcing,                                            &
-               large_scale_subsidence,                                         &
-               loop_optimization, masking_method, mask_scale_x, mask_scale_y,  &
-               mask_scale_z, mask_x, mask_y, mask_z, mask_x_loop,              &
-               mask_y_loop, mask_z_loop, maximum_cpu_time_allowed,             &
-               maximum_parallel_io_streams, max_pr_user, message_string,       &
-               mg_cycles, mg_switch_to_pe0_level, mixing_length_1d,            &
-               momentum_advec, most_method, netcdf_data_format,                &
-               netcdf_precision, neutral, ngsrb, normalizing_region, nsor,     &
-               nsor_ini, nudging, ocean,                                       &
-               omega, omega_sor, passive_scalar, phi, nz_do3d,                 &
-               prandtl_number, precipitation,                                  &
-               precipitation_amount_interval, psolver, pt_damping_factor,      &
-               pt_damping_width, pt_reference, pt_surface,                     &
-               pt_surface_initial_change, pt_vertical_gradient,                &
-               pt_vertical_gradient_level, q_surface,                          &
-               q_surface_initial_change, q_vertical_gradient,                  &
-               q_vertical_gradient_level, random_generator,                    &
-               random_heatflux, rayleigh_damping_factor,                       &
-               rayleigh_damping_height, recycling_width, recycling_yshift,     &
-               reference_state, residual_limit,                                &
-               restart_time, return_addres, return_username,                   &
-               revision, roughness_length, runnr,                              &
-               run_identifier, sa_surface, sa_vertical_gradient,               &
-               sa_vertical_gradient_level, scalar_advec,                       &
-               scalar_rayleigh_damping,                                        &
-               section_xy, section_xz, section_yz, skip_time_data_output,      &
-               skip_time_data_output_av, skip_time_dopr, skip_time_do2d_xy,    &
-               skip_time_do2d_xz, skip_time_do2d_yz, skip_time_do3d,           &
-               skip_time_domask, subs_vertical_gradient,                       &
-               subs_vertical_gradient_level, surface_heatflux,                 &
-               surface_pressure, surface_scalarflux, surface_waterflux,        &
-               synchronous_exchange,s_surface, s_surface_initial_change,       &
-               s_vertical_gradient, s_vertical_gradient_level,                 &
-               termination_time_needed, timestep_scheme, topography,           &
-               topography_grid_convention, top_heatflux,  top_momentumflux_u,  &
-               top_momentumflux_v, top_salinityflux,                           &
-               transpose_compute_overlap, turbulence, turbulent_inflow,        &
-               ug_surface, ug_vertical_gradient, ug_vertical_gradient_level,   &
-               use_subsidence_tendencies, use_surface_fluxes, use_cmax,        &
-               use_top_fluxes, use_ug_for_galilei_tr, use_upstream_for_tke,    &
-               uv_heights, u_bulk, u_profile, vg_surface, vg_vertical_gradient,&
-               vg_vertical_gradient_level, v_bulk, v_profile,                  &
-               wall_adjustment, wall_heatflux, wall_humidityflux,              &
-               wall_scalarflux, write_binary, zeta_max, zeta_min, z0h_factor,  &
-               z_max_do2d
+    USE control_parameters
 
     USE cpulog,                                                                &
@@ -418,4 +342,26 @@
           READ ( 11, inipar, ERR=10, END=11 )
 
+#if defined ( PMC_ACTIVE )
+!
+!--       In nested domains, npex or npey must not be given in \$inipar
+!--       because here the PE-grids are always defined in the nestpar-NAMELIST
+          IF ( ( npex /= -1 ) .OR. ( npey /= -1 ) )  THEN
+             message_string = 'npex or npey must not be given in \$inipar ' // &
+                              'in nested domains'
+             CALL message( 'parin', 'PAXXXX', 1, 2, 0, 6, 0 )
+          ENDIF
+#else
+!
+!--       Make sure that no nesting boundary conditions are defined if
+!--       PMC_ACTIVE is not defined. Otherwise initiate abort.
+          IF ( ( bc_lr == 'nested' ) .OR. ( bc_ns == 'nested' ) .OR. ( bc_uv_t == 'nested' ) .OR. &
+               ( bc_pt_t ==  'nested' ) .OR. ( bc_q_t == 'nested') .OR. ( bc_sa_t == 'nested') .OR. &
+               ( bc_p_t == 'nested' ) ) THEN
+             message_string = 'Nested boundary conditions are not allowed ' // &
+                              'since the cpp flag PMC_ACTIVE is not set'
+             CALL message( 'parin', 'PAXXXX', 1, 2, 0, 6, 0 )
+          ENDIF
+#endif
+
 #if defined ( __check )
 !
